using GrapeCity.ActiveReports;
using GrapeCity.ActiveReports.SectionReportModel;
using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Linq;

namespace JSViewerCoreMVCApplicationSample
{
    /// <summary>
    /// Summary description for SectionReport1.
    /// </summary>
    public partial class SectionReport1 : SectionReport
    {
        SectionReport rpt;
        private IEnumerator<OrderData> datasource = null;
        public SectionReport1()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();
            this.ReportStart += SectionReport1_ReportStart;
        }
        private IEnumerable<OrderData> GetIEnumerableData()
        {
            List<OrderData> data = new List<OrderData>
            {
                new OrderData { OrderID = "1", Freight = 10.5, CustomerName = "Jane" },
                new OrderData { OrderID = "2", Freight = 15.2, CustomerName = "Margret" },
            };
            return data;
        }
        private void SectionReport1_ReportStart(object sender, EventArgs e)
        {
            rpt = new SectionReport();
            System.Xml.XmlTextReader xtr = new System.Xml.XmlTextReader("Reports\\SubReport.rpx");
            rpt.LoadLayout(xtr);
            xtr.Close();
        }

        private void detail_Format(object sender, EventArgs e)
        {
            SubReport rptSubCtl = this.subReport1;
            rptSubCtl.Report = rpt;
        }
        private void SectionReport1_DataInitialize(object sender, EventArgs e)
        {
            this.Fields.Add("OrderID");
            this.Fields.Add("Freight");
            this.Fields.Add("CustomerName");
            rpt.Fields.Add("OrderID");
            rpt.Fields.Add("Freight");
            rpt.Fields.Add("CustomerName");
            datasource = GetIEnumerableData().GetEnumerator();
        }

        private void SectionReport1_FetchData(object sender, FetchEventArgs eArgs)
        {
            if (datasource.MoveNext())
            {
                var currentData = datasource.Current;
                this.Fields["OrderID"].Value = currentData.OrderID;
                this.Fields["Freight"].Value = currentData.Freight;
                this.Fields["CustomerName"].Value = currentData.CustomerName;
                rpt.Fields["OrderID"].Value = currentData.OrderID;
                rpt.Fields["Freight"].Value = currentData.Freight;
                rpt.Fields["CustomerName"].Value = currentData.CustomerName;
                eArgs.EOF = false;
            }
            else
                eArgs.EOF = true;
        }
    }
    public class OrderData
    {
        public string OrderID { get; set; }
        public double Freight { get; set; }
        public string CustomerName { get; set; }
    }
}
